declare function exportWorker<T extends (...args: any) => any>(fn: T): T;

declare enum WORKER_STATUS {
    PENDING = "PENDING",
    RUNNING = "RUNNING",
    SUCCESS = "SUCCESS",
    ERROR = "ERROR",
    TIME_OUT = "TIME_OUT"
}
declare function useWorker<R extends (...args: any) => any>(createWorker?: () => Worker, options?: {
    autoTerminate?: boolean;
    timeout?: number;
}): {
    workerRunner: (...fnArgs: Parameters<R>) => Promise<never> | (ReturnType<R> extends Promise<infer K> ? Promise<K> : Promise<ReturnType<R>>);
    workerController: {
        workerStatus: WORKER_STATUS;
        killWorker: () => void;
    };
};

export { WORKER_STATUS, useWorker as default, exportWorker };
